image: node:16-alpine
stages:
  - setup
  - test

before_script:
  - apk add --update git
  - apk add --update nodejs npm

install-dependencies:
  stage: setup
  interruptible: true
  only:
    - main
    - merge_requests
    - tags
  cache:
    key:
      files:
        - yarn.lock
    paths:
      - node_modules
      - .yarn
  script:
    - yarn install --pure-lockfile --cache-folder .yarn
  artifacts:
    paths:
      - node_modules

.distributed:
  interruptible: true
  only:
    - main
    - merge_requests
    - tags
  needs:
    - install-dependencies
  artifacts:
    paths:
      - node_modules/.cache/nx

build:
  stage: test
  extends: .distributed
  script:
    - yarn nx affected --base=HEAD~1 --target=build --parallel=3

test:
  stage: test
  extends: .distributed
  script:
    - yarn nx affected --base=HEAD~1 --target=test --parallel=2